#.------------------------------------------------------------,
#| Compact Flash Builder - IBM Embedded Linux Network Station |
#|                                                            |
#| This code originally developed by:                         |
#| Ryan Harper and Christopher Glendenning                    |
#| March, April 2000                                          |
#|                                                            |
#| Filename: proginit.tcl                                     |
#| Last Modified: April 26, 2000 by Ryan Harper               |
#| Changes: added quick key, F2, for view log 04.26.00 RAH    |
#|          added new global dir vars 4.7.00 CMG              |
#| Description: contains all of the key bindings and          |
#|     initGlobalVars which initializes all global variables  |
#`------------------------------------------------------------'

global CFBUILD_DIR_NO_SLASH

#-----------------------Key bindings------------------
#Quick menu access keys
bind All <Alt-F> {}
bind All <Alt-B> {}
bind All <Alt-S> {}
bind All <Alt-U> {}
bind All <Alt-H> {}

#accelerators
bind . <Control-x> {exit} ;#exit the program
bind . <Control-i> {select_packages "0"} ;#Image page
bind . <Control-p> {build_packages "0"} ;#Package page
bind . <Control-d> {choose_settings "0"} ;#Settings page
bind . <Control-m> {MOO} ;#Management page
bind . <Control-n> {MOO} ;#Network page
bind . <Control-w> {intro "1"} ;#Start Wizard
#bind . <Control-f> {MOO}  ;#Format page
#bind . <Control-u> {MOO}  ;#Mount page
bind . <Control-b> {backup_restore "0"} ;#Backup/Restore page
bind . <Control-r> {create_partition "0"} ;#Partition page
bind . <F1> {showAbout} ;#Help About
bind . <F2> {view_log} ;#Open Log File
bind . <F3> {show_help_file "$CFBUILD_DIR_NO_SLASH/IPL" "IBM Corporation License"} ;# Show License

#---------------------End Key bindings-----------------

#---------------------Initialize Globals---------------
# procedure to initialize all global vars needed to run program

proc initGlobalVars {} {
    global CFBUILD_DIR_NO_SLASH
    global CFBUILD_DIR
    global CUSTOM_DIR
    global INSTALLDOC_DIR
    global PARTITION_DIR
    global SCRIPT_DIR
    global BOOTDIR
    global NETSCAPE_ROOT
    global IBM_JVM_ROOT
    global GTK_SOURCE
    global REAL7_ROOT
    global INSTALL_DEST
    global INSTALL_SOURCE
    global FVWM2_SOURCE
    global FVWM2_ICON_SOURCE
    global GIMP_SOURCE
    global GIMP_LIB_SOURCE
    global REAL7_SOURCE
    global IBM_JVM_SOURCE
    global BACKUP_SOURCE
    global RESTORE_SOURCE
    global ICA_SOURCE

    set BOOTDIR "/"
    set CUSTOM_DIR "Custom"
    set INSTALLDOC_DIR "Installdocs"
    set PARTITION_DIR "Partition"
    set SCRIPT_DIR "Scripts"
    set NETSCAPE_ROOT "/opt/netscape"
    set IBM_JVM_ROOT "/usr/java"
    set REAL7_ROOT "/usr/realplayer7"
    set INSTALL_DEST "/"
    set INSTALL_SOURCE "/"
    set FVWM2_SOURCE "/"
    set FVWM2_ICON_SOURCE "/"
    set GIMP_SOURCE "/"
    set GIMP_LIB_SOURCE "/"
    set GTK_SOURCE "/"
    set REAL7_SOURCE "/"
    set IBM_JVM_SOURCE "/"
    set BACKUP_SOURCE "/"
    set RESTORE_SOURCE "/"
    set ICA_SOURCE "/"

    global soundMaster
    global res
    global depth
    global clientServerConfigure
    global clientServerIP
    global clientROMFlash
    global clientCompactFlash

    set soundMaster "50"
    set res "640"
    set depth "8"
    set clientServerConfigure "0"
    set clientServerIP "0.0.0.0"
    set clientROMFlash "1"
    set clientCompactFlash "1"

    global types
    set types {
            {{RPM Files} {.rpm}}
            {{Z Files} {.Z}}
            {{Tgz Files} {.tgz}}
			{{Gzip Files} {.gz}}
			{{Tar Files} {.tar}}
            {{All Files} {.*}}
		}
}
#-------------------End InitGlobs---------------------
