#-------------------Build Packages Frame --------------------------------------

proc build_packages {show_next_back} {
    check_for_win {.win}

    global lh
    puts $lh [format "%s" "Starting build_packages"]
    puts $lh [format "%s=%s" "Running_in_Wizmode" "$show_next_back"]
    flush $lh

    #---internal procedures----------------------

    proc netscape_install {} {
	global NETSCAPE_ROOT
	global INSTALL_DEST
	global INSTALL_SOURCE
	global CFBUILD_DIR
	global CUSTOM_DIR
	global INSTALLDOC_DIR
	global SCRIPT_DIR

	global lh
	puts $lh [format "%s" "Starting netscape_install"]
	flush $lh



	set INSTALL_DIR "installtemp"
	file mkdir $CFBUILD_DIR$INSTALL_DIR
	set ROOT $CFBUILD_DIR$INSTALL_DIR
	cd $ROOT
	#tk_messageBox -message $ROOT
	update
	toplevel .top -width 250 -height 150
	wm resizable .top 0 0
	wm title .top " "
	label .top.message -text "Unpacking..."
	pack .top.message -padx 50 -pady 50
	centerwin .top
	#	wm geometry .top +360+340
	update
	exec tar -xzf $NETSCAPE_ROOT
	.top.message configure -text "Done"
	after 1000
	destroy .top
	exec find > installdir
	set INSTALL_FILE "/installdir"
	set file $ROOT$INSTALL_FILE
	#tk_messageBox -message $file
	set fh [open $file r]
	gets $fh INSTALL_SOURCE
	gets $fh INSTALL_SOURCE
	set INSTALL_SOURCE [string trimleft $INSTALL_SOURCE {./}]
	set INSTALL_SOURCE "$ROOT/$INSTALL_SOURCE"
	set LOCAL "/tar"
	set INSTALL_DEST $ROOT$LOCAL
	SaveInstallDir "$INSTALL_DEST" "$INSTALL_SOURCE"
	cd $CFBUILD_DIR
	action_window "Building Netscape Package...\nPlease Wait"\
	  "./ns-install.sh" "ns-install.log" "Build Complete"
	return
    }

    proc ibm_jvm_install {} {
	global lh
	puts $lh [format "%s" "Starting ibm_jvm_install"]
	flush $lh
	action_window "Building IBM JVM Package...\nPlease Wait"\
	  "./IBM_JVM_tarbuilder.sh" "IBM_JVM.log" "Build Complete"
    }

    proc real7_install {} {
	global lh
	puts $lh [format "%s" "Starting real7_install"]
	flush $lh
	action_window "Building RealPlayer7 Package...\nPlease Wait"\
	  "./real7_tarbuilder.sh" "real7.log" "Build Complete"
    }

    proc gimp_install {} {
	global lh
	puts $lh [format "%s" "Starting gimp_install"]
	flush $lh
	action_window "Building Gimp Package...\nPlease Wait"\
	  "./gimp_tarbuilder.sh" "gimp.log" "Build Complete"
    }

    proc ica_install {} {
	global lh
	puts $lh [format "%s" "Starting ica_install"]
	flush $lh
	action_window "Building ICA Client Package...\nPlease Wait."\
	  "./ica_tarbuilder.sh" "ica.log" "Build Complete"
    }


    #---globals needed---------------------------
    global BOOTDIR
    global NETSCAPE_ROOT
    global INSTALL_DEST
    global INSTALL_SOURCE
    global IBM_JVM_ROOT
    global GTK_SOURCE
    global REAL7_ROOT
    global INSTALL_DEST
    global INSTALL_SOURCE
    global netscape_mesg
    global netscape_build_cmd
    global netscape_help_cmd
    global ibm_jvm_mesg
    global ibm_jvm_build_cmd
    global ibm_jvm_help_cmd
    global real7_mesg
    global real7_build_cmd
    global real7_help_cmd
    global gimp_mesg
    global gimp_build_cmd
    global gimp_help_cmd
    global ica_mesg
    global ica_build_cmd
    global ica_help_cmd

    set netscape_mesg "    Netscape Navigator 4.7 Installation \n\n\n Please\
      click the Help button to find out\n how to download Netscape 4.7 to your\
      System.\n\n When the download is finished click on Build\n to generate\
      the Package. Packages only\n need to be built once.\n"
    set netscape_build_cmd "get_dir \"Where is the Netscape Install Package?\"\
      \"netscape\" \"1\" \"finish netscape_install\""
    set netscape_help_cmd "show_help_file \"netscape_install.doc\" \"Netscape\
      4.7x Installation Intructions\""

    set ibm_jvm_mesg "      IBM JVM for Linux Installation \n\n\n Please click\
      the Help button to find out\n how to install the IBM JVM on your\
      System.\n\n When installation is finished click on	Build\n to generate\
      the Package. Packages only\n need to be built once.\n"
    set ibm_jvm_build_cmd "get_dir \"Where is the IBM JVM Install file?\"\
      \"jvm\" \"1\" \"finish ibm_jvm_install\""
    set ibm_jvm_help_cmd "show_help_file \"IBM_JVM_install.doc\" \"IBM JVM\
      Installation Intructions\""

    set real7_mesg "\tRealPlayer 7 Installation \n\n\n Please click the Help\
      button to find out\n how to install RealPlayer 7  on your System.\n\n\
      When installation is finished click on	Build\n to generate the Package.\
      Packages only\n need to be built once.\n"
    set real7_build_cmd "get_dir \"Where is the RealPlayer 7 Install file?\"\
      \"real7\" \"1\" \"finish real7_install\""
    set real7_help_cmd "show_help_file \"real7_install.doc\" \"RealPlayer7\
      Installation Instructions\""

    set gimp_mesg "\tGimp Installation \n\n\n Please click the Help button to\
      find out\n how to install Gimp  on your System.\n\n When installation is\
      finished click on	Build\n to generate the Package. Packages only\n need\
      to be built once.\n"
    set gimp_build_cmd "get_dir \"Where are the Gimp RPM files?\n(Main file\
      and Libraries (2))\" \"gimp\" \"3\" \"finish gimp_install\""
    set gimp_help_cmd "show_help_file \"gimp_install.doc\" \"Gimp Installation\
      Instructions\""

    set ica_mesg "      ICA Client for Linux Installation \n\n\n Please click\
      the Help button to find out\n how to install the ICA Client on your\
      System.\n\n When installation is finished click on	Build\n to generate\
      the Package. Packages only\n need to be built once.\n"
    set ica_build_cmd "\get_dir \"Where is the ICA Client Install file?\"\
      \"ica\" \"1\" \"finish ica_install\""
    set ica_help_cmd "show_help_file \"ica_install.doc\" \"ICA Client\
      Installation Instructions\""


    #---destroy duplicate windows----------------
    if {[winfo exists .win]} {
	wm deiconify .win
	return
    }

    #---set win size,title,focus, and center win-
    set win [toplevel .win -width 500 -height 300]
    wm title .win {IBM Linux Setup - Software Package Creation}
    wm geometry .win 500x300+312+134
    focus -force .win
    wm resizable .win 0 0
    centerwin .win

    #---build frames-----------------------------
    frame .win.left -width 200 -height 300
    frame .win.right -width 300 -height 250
    frame .win.rightbottom -width 300 -height 50
    frame .win.left.sep -width 2 -height 300 -borderwidth 2 -relief sunken
    frame .win.right.sep -width 300 -height 2 -borderwidth 2 -relief sunken

    #---add wizard buttons if show_next_back set-
    if {$show_next_back} {
	button .win.left.next -text {Next >} -command {ChangePage\
	  "create_partition" "1"}
	button .win.left.back -text {< Back} -command {ChangePage "intro" "1"}
	place .win.left.back -x 8 -y 260
	place .win.left.next -x 85 -y 260

    }

    #---build buttons, call appropriate build func
    #---based on package selected----------------
    button .win.left.ica -width 15 -text {ICA Client}\
      -command {install_program $ica_mesg $ica_build_cmd $ica_help_cmd}
    button .win.left.netscape -width 15 -text {Netscape 4.7}\
      -command {install_program $netscape_mesg $netscape_build_cmd\
      $netscape_help_cmd}
    button .win.left.gimp -width 15 -text {Gimp} -command\
      {install_program $gimp_mesg $gimp_build_cmd $gimp_help_cmd}
    button .win.left.real7 -width 15 -text {RealPlayer 7}\
      -command {install_program $real7_mesg $real7_build_cmd $real7_help_cmd}
    button .win.left.jvm -width 15 -text {IBM Linux JVM}\
      -command {install_program $ibm_jvm_mesg $ibm_jvm_build_cmd\
      $ibm_jvm_help_cmd}
    button .win.rightbottom.build -width 15 -text {Build Package} -command ""\
      -state disabled
    button .win.rightbottom.install -width 15 -text {Help} -command ""\
      -state disabled

    label .win.right.startmesg -justify "left" -text " Click the button on the\
      left corresponding\n to the Package you wish to install.\n "

    #---place objects----------------------------
    place .win.left -x 0 -y 0
    place .win.left.ica -x 10 -y 20
    place .win.left.jvm -x 10 -y 60
    place .win.left.gimp -x 10 -y 100
    place .win.left.netscape -x 10 -y 140
    place .win.left.real7 -x 10 -y 180
    place .win.left.sep -x 160 -y 0
    place .win.right -x 180 -y 0
    place .win.right.startmesg -x 15 -y 25
    place .win.right.sep -x 0 -y 245
    place .win.rightbottom -x 180 -y 250
    place .win.rightbottom.build -x 0 -y 10
    place .win.rightbottom.install -x 170 -y 10



}
