#.------------------------------------------------------------,
#| Compact Flash Builder - IBM Embedded Linux Network Station |
#|                                                            |
#| This code originally developed by:                         |
#| Ryan Harper and Christopher Glendenning                    |
#| March, April 2000                                          |
#|                                                            |
#| Filename: wiz_intro.tcl                                    |
#| Last Modified: April 7, 2000 by Chris Glendenning          |
#| Changes:                                                   |
#| Description: introduction page; Used to invoke the wizard. |
#`------------------------------------------------------------'

proc intro {show_next_back} {

    if {[check_for_win {.win}]} {
	return
    }

    set wizardfile "/root/IBM/RunCFWiz"
    set wfh [open $wizardfile w]
    close $wfh

    global BOOTDIR
    global NETSCAPE_ROOT
    global IBM_JVM_ROOT
    global GTK_SOURCE
    global REAL7_ROOT
    global INSTALL_DEST
    global INSTALL_SOURCE

    set win [toplevel .win -width 400 -height 300]
    wm title .win {IBM Linux Setup - Welcome!}
    wm geometry .win 400x300+312+134
    focus -force .win
    wm resizable .win 0 0
    centerwin .win

    frame .win.sep -width 400 -height 2 -borderwidth 1 -relief sunken
    frame .win.space -width 400 -height 120

    label .win.welcome -justify "left" -text " Welcome to Embedded Linux for\
      the IBM NetworkStation\n Setup Programs. This program will help install\
      and build\n Software Packages to make an image for use with Compact\n\
      Flash Media.\n\n This program should be run on an IBM NetworkStation\n\
      booted to a Linux Server.  The Compact Flash Media\n should already be\
      inserted into the NetworkStation\n If the Compact Flash Media is not in\
      the NetworkStation,\n please turn off the NetworkStation, place the\
      Compact\n Flash Media into the NetworkStation and reboot.\n\n"

    if {$show_next_back} {
	set show_next_back "1"
	button .win.next -width 5 -text {Next >} -command {ChangePage\
	  "build_packages" "1"}
	button .win.exit -width 5 -text {Exit} -command {cexit}
	place .win.next -x 85 -y 260
	place .win.exit -x 8 -y 260
    }


    place .win.welcome -x 10 -y 10
    place .win.sep -x 0 -y 250

    focus .win.next
    focus -force .win

}
