#.------------------------------------------------------------,
#| Compact Flash Builder - IBM Embedded Linux Network Station |
#|                                                            |
#| This code originally developed by:                         |
#| Ryan Harper and Christopher Glendenning                    |
#| March, April 2000                                          |
#|                                                            |
#| Filename: wiz_partition.tcl                                |
#| Last Modified: April 11, 2000 by RAH                       |
#| Changes: added auto_partition 04.26.00 RAH                 |
#|          added variable dir name support 04.11.00 RAH      |
#| Description: allows user to partition their compact flash  |
#`------------------------------------------------------------'
proc create_partition {show_next_back} {
    check_for_win {.win}
    global lh
    puts $lh [format "%s" "Starting create_partition"]
    puts $lh [format "%s=%s" "Running_in_Wizmode" "$show_next_back"]
    flush $lh
    global CFBUILD_DIR
    global CFBUILD_DIR_NO_SLASH
    global SCRIPT_DIR
    global PARTITION_DIR

    if {[winfo exists .win]} {
	wm deiconify .win
	return
    }

    set win [toplevel .win -width 500 -height 300]
    wm title .win {IBM Linux Setup - Compact Flash Partitioning}
    wm geometry .win 500x300+312+134
    centerwin .win
    focus -force .win
    wm resizable .win 0 0

    frame .win.left -width 200 -height 300
    place .win.left -x 0 -y 0

    frame .win.left.sep -width 2 -height 300 -borderwidth 2 -relief sunken
    place .win.left.sep -x 160 -y 0

    label .win.left.label_size -text "Select size of Media"
    place .win.left.label_size -x 8 -y 20


    radiobutton .win.left.size32 -variable current -value "32" -text "32 MB"
    radiobutton .win.left.size48 -variable current -value "48" -text "48 MB"
    radiobutton .win.left.size64 -variable current -value "64" -text "64  MB"
    radiobutton .win.left.size96 -variable current -value "96" -text "96 MB"
    radiobutton .win.left.size128 -variable current -value "128" -text "128 MB"

    place .win.left.size32 -x 20 -y 70
    place .win.left.size48 -x 20 -y 100
    place .win.left.size64 -x 20 -y 130
    place .win.left.size96 -x 20 -y 160
    place .win.left.size128 -x 20 -y 190

    .win.left.size32 invoke

    if {$show_next_back} {
	button .win.left.next -text {Next >} -command {ChangePage\
	  "select_packages" "1"}
	button .win.left.back -text {< Back} -command {ChangePage\
	  "build_packages" "1"}
	place .win.left.back -x 8 -y 260
	place .win.left.next -x 85 -y 260
    }


    frame .win.right -width 300 -height 300
    place .win.right -x 180 -y 0

    label .win.right.label_warning -justify "left" -text "Please select the\
      size of Compact Flash Media\n to partition and click Partition.  Make\
      sure that\n the Media is already in the NetworkStation.  If\n the Media\
      is not in the NetworkStation, please\n turn off the NetworkStation,\
      insert a Compact\n Flash Media, and reboot.\n\n WARNING! - Make sure\
      that you select the \n correct size for your Compact Flash Media. All\n\
      data on device /dev/hda will be ERASED\n PERMANENTLY.\n\n"

    place .win.right.label_warning -x 12 -y 20

    frame .win.right.sep -width 300 -height 2 -borderwidth 2 -relief sunken
    place .win.right.sep -x 0 -y 245

    button .win.right.button_partition -width 20 -text "PARTITION"\
      -command confirm_partition
    place .win.right.button_partition -x 65 -y 260


    proc confirm_partition {} {
	global current
	if {[confirm_ask "Do you really want to write the Partition?"]} {
	    auto_partition
	}
    }
}

proc auto_partition {} {
    cf_partition
    cf_format
    cf_mount
    tk_messageBox -message "Compact Flash Initialization Complete"
}
